<?php

namespace App\Console;

use App\Service\DatabaseService;
use App\Service\Traits\SelectDatabaseQuestion;
use Symfony\Component\Console\Attribute\AsCommand;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

#[AsCommand('app:permissions:list')]
class CreatePermissionCommand extends Command
{
    use SelectDatabaseQuestion;

    public function __construct(
        private readonly DatabaseService $db,
    )
    {
        parent::__construct();
    }

    public function configure(): void
    {
        $this->addArgument('name', InputArgument::OPTIONAL, 'User name');
        $this->addArgument('host', InputArgument::OPTIONAL, 'User host');
        $this->addArgument('database', InputArgument::OPTIONAL, 'Database');
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $dbs = $this->db->listDatabases();

        $output->writeln('List of permissions for user:');
        foreach ($dbs as $db) {
            $output->writeln(sprintf(' -%s', $db));
        }

        return Command::SUCCESS;
    }
}